////////////////////////////////////////////////////////////
//Project: NDemia CashMatic Demo plugin. v.1.0.0
//
//	Step 2.
//
//(C)opyright NDemia 2009
////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "CashMaticDemoPlugin.h"
#include <assert.h>
#include <wchar.h>

IID IID_ICashMaticPlugin = { 0x1288b75, 0xb4ea, 0x4d76, { 0x83, 0x22, 0x8b, 0x5a, 0xc4, 0xe8, 0x99, 0x95 } };
//  ICashMaticPlugin (   NDemia CashMatic)

const CLSID CCashMaticDemoPlugin::ClsId = 
{ 0x188e65e, 0xd900, 0x4056, { 0xac, 0x46, 0xc0, 0x46, 0x78, 0xe7, 0x9c, 0x6 } };

//  ICashMaticPlugin   IDispatch
//	( ,     ,
//	,     NDemia CashMatic   
//	,     )

// CashMatic
static PARAMDATA Param_CashMatic = {OLESTR("CashMatic"), VT_DISPATCH};

// ICashMaticPlugin, 
static METHODDATA ICashMaticPlugin_Methods[] =
{
	{OLESTR("Init"), &Param_CashMatic, 1, 7, CC_STDCALL, 1, DISPATCH_METHOD, VT_EMPTY},
};

// ICashMaticPlugin
static INTERFACEDATA ICashMaticPlugin_Interface = {ICashMaticPlugin_Methods, 1};

////////////////////////////////////////////////////////////
// CCashMaticDemoPlugin (  "CashMaticDemoPlugin.h")
////////////////////////////////////////////////////////////
//
CCashMaticDemoPlugin::CCashMaticDemoPlugin()
	:RefCount(1),
	pTypeInfo(NULL)
{
	//     ICashMaticPlugin
	CreateDispTypeInfo(&ICashMaticPlugin_Interface, LOCALE_SYSTEM_DEFAULT, &pTypeInfo);
		//  : S_OK,   
}

//
CCashMaticDemoPlugin::~CCashMaticDemoPlugin()
{
	if(pTypeInfo)
		pTypeInfo->Release();
}

// IUnknown
HRESULT CCashMaticDemoPlugin::QueryInterface(REFIID iid, void ** ppvObject)
{
	if(ppvObject)
	{
		if(IsEqualIID(iid, IID_IUnknown) || IsEqualIID(iid, IID_IDispatch) || IsEqualIID(iid, IID_ICashMaticPlugin))
		{
			*ppvObject = this;
			AddRef();
			return S_OK;
		}
		else
		{
			*ppvObject = NULL;
			return E_NOINTERFACE;
		}
	}
	else
		return E_INVALIDARG;
}

// IUnknown
ULONG CCashMaticDemoPlugin::AddRef()
{
	return InterlockedIncrement(&RefCount);
}

// IUnknown
ULONG CCashMaticDemoPlugin::Release(void)
{
		LONG cnt = InterlockedDecrement(&RefCount);
		if(!cnt)
				delete this;
		return cnt;
}

// IDispatch
HRESULT CCashMaticDemoPlugin::GetTypeInfoCount(unsigned int* pctinfo)
{
	if(pctinfo)
	{
		*pctinfo = 1;
		return S_OK;
	}
	else
		return E_INVALIDARG;
}


// IDispatch
HRESULT CCashMaticDemoPlugin::GetTypeInfo(unsigned int iTInfo, LCID lcid, ITypeInfo** ppTInfo)
{
	if(ppTInfo)
	{
		*ppTInfo = pTypeInfo;
		pTypeInfo->AddRef();
		return S_OK;
	}
	else
		return E_INVALIDARG;
}

// IDispatch
HRESULT CCashMaticDemoPlugin::GetIDsOfNames(REFIID riid, OLECHAR** rgszNames, unsigned int cNames, LCID lcid, DISPID* rgDispId)
{
	return DispGetIDsOfNames(pTypeInfo, rgszNames, cNames, rgDispId);
}

// IDispatch
HRESULT CCashMaticDemoPlugin::Invoke(DISPID dispIdMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult, EXCEPINFO* pExcepInfo, unsigned int FAR* puArgErr)
{
	return DispInvoke(this, pTypeInfo, dispIdMember, wFlags, pDispParams, pVarResult, pExcepInfo, puArgErr);
}

// ICashMaticPlugin
void CCashMaticDemoPlugin::Init(IDispatch* pCashMatic)
{
		MessageBox(0, TEXT("  Init"), TEXT("CashMatic Demo plugin"), MB_OK);

		//   .

		//  ,             COM-.
		//	    VariantInit, VariantClear, VariantChangeType, SysAllocString, GetIDsOfNames, Invoke  .. -      COM/OLE/ActiveX

		//     (   )


		HRESULT hr;
		DISPID dispid;

		OLECHAR* szHost = OLESTR("Host");
		hr = pCashMatic->GetIDsOfNames(IID_NULL, &szHost, 1, LOCALE_SYSTEM_DEFAULT, &dispid);
		assert(hr == S_OK);

		VARIANT Host;
		VariantInit(&Host);

		DISPPARAMS NoParams = {NULL, NULL, 0, 0};
		hr = pCashMatic->Invoke(dispid, IID_NULL, LOCALE_SYSTEM_DEFAULT, DISPATCH_PROPERTYGET, &NoParams, &Host, NULL, NULL);
		assert(hr == S_OK);
		assert(Host.vt == VT_DISPATCH);
		//Ok,    CashMaticHost

		//  
		{
			VARIANT Result;
			VariantInit(&Result);
			OLECHAR* szName = OLESTR("Name");
			hr = Host.pdispVal->GetIDsOfNames(IID_NULL, &szName, 1, LOCALE_SYSTEM_DEFAULT, &dispid);
			assert(hr == S_OK);
			hr = Host.pdispVal->Invoke(dispid, IID_NULL, LOCALE_SYSTEM_DEFAULT, DISPATCH_PROPERTYGET, &NoParams, &Result, NULL, NULL);
			assert(hr == S_OK);
			hr = VariantChangeType(&Result, &Result, 0, VT_BSTR);
			assert(hr == S_OK);

			MessageBoxW(0, Result.bstrVal, L"CashMatic.Host.Name", MB_OK);
				//  NDemia CashMatic KioskBrowser

			VariantClear(&Result);
		}

		//     NDemia CashMatic
		{
			VARIANT Result;
			VariantInit(&Result);
			OLECHAR* szPath = OLESTR("Path");
			hr = Host.pdispVal->GetIDsOfNames(IID_NULL, &szPath, 1, LOCALE_SYSTEM_DEFAULT, &dispid);
			assert(hr == S_OK);
			hr = Host.pdispVal->Invoke(dispid, IID_NULL, LOCALE_SYSTEM_DEFAULT, DISPATCH_PROPERTYGET, &NoParams, &Result, NULL, NULL);
			assert(hr == S_OK);
			hr = VariantChangeType(&Result, &Result, 0, VT_BSTR);
			assert(hr == S_OK);

			MessageBoxW(0, Result.bstrVal, L"CashMatic.Host.Path", MB_OK);

			VariantClear(&Result);
		}

		//  
		{
			VARIANT Result;
			VariantInit(&Result);
			OLECHAR* szVersion = OLESTR("Version");
			hr = Host.pdispVal->GetIDsOfNames(IID_NULL, &szVersion, 1, LOCALE_SYSTEM_DEFAULT, &dispid);
			assert(hr == S_OK);
			hr = Host.pdispVal->Invoke(dispid, IID_NULL, LOCALE_SYSTEM_DEFAULT, DISPATCH_PROPERTYGET, &NoParams, &Result, NULL, NULL);
			assert(hr == S_OK);
			hr = VariantChangeType(&Result, &Result, 0, VT_BSTR);
			assert(hr == S_OK);

			MessageBoxW(0, Result.bstrVal, L"CashMatic.Host.Version", MB_OK);

			VariantClear(&Result);
		}

		//   :  URL  
		{
			VARIANTARG Param;
			VariantInit(&Param);
			Param.vt = VT_BSTR;
			Param.bstrVal = SysAllocString(L"start");
			DISPPARAMS DispParams = {&Param, NULL, 1, 0};
			VARIANT Result;
			VariantInit(&Result);
			OLECHAR* szGetSpecialURL = OLESTR("GetSpecialURL");
			hr = Host.pdispVal->GetIDsOfNames(IID_NULL, &szGetSpecialURL, 1, LOCALE_SYSTEM_DEFAULT, &dispid);
			assert(hr == S_OK);
			hr = Host.pdispVal->Invoke(dispid, IID_NULL, LOCALE_SYSTEM_DEFAULT, DISPATCH_METHOD, &DispParams, &Result, NULL, NULL);
			assert(hr == S_OK);
			hr = VariantChangeType(&Result, &Result, 0, VT_BSTR);
			assert(hr == S_OK);

			MessageBoxW(0, Result.bstrVal, L"CashMatic.Host.GetSpecialURL(\"start\")", MB_OK);

			VariantClear(&Result);
			VariantClear(&Param);
		}

		//   "start" -  (URL   ),
		//	  ( ) , , "demo"
		{
			VARIANTARG Param;
			VariantInit(&Param);
			Param.vt = VT_BSTR;
			Param.bstrVal = SysAllocString(L"demo");
			DISPPARAMS DispParams = {&Param, NULL, 1, 0};
			VARIANT Result;
			VariantInit(&Result);
			OLECHAR* szGetSpecialURL = OLESTR("GetSpecialURL");
			hr = Host.pdispVal->GetIDsOfNames(IID_NULL, &szGetSpecialURL, 1, LOCALE_SYSTEM_DEFAULT, &dispid);
			assert(hr == S_OK);
			hr = Host.pdispVal->Invoke(dispid, IID_NULL, LOCALE_SYSTEM_DEFAULT, DISPATCH_METHOD, &DispParams, &Result, NULL, NULL);
			assert(hr == S_OK);
			hr = VariantChangeType(&Result, &Result, 0, VT_BSTR);
			assert(hr == S_OK);

			MessageBoxW(0, Result.bstrVal, L"CashMatic.Host.GetSpecialURL(\"demo\")", MB_OK);

			VariantClear(&Result);
			VariantClear(&Param);
		}

		//  :   finish URL //CashMatic.Host.Navigate(CashMatic.Host.GetSpecialURL("finish"))
		//	( ,     NDemia CashMatic    , 
		//	         ,     ).
		{
			VARIANTARG Param;
			VariantInit(&Param);
			Param.vt = VT_BSTR;
			Param.bstrVal = SysAllocString(L"finish");
			DISPPARAMS DispParams = {&Param, NULL, 1, 0};
			VARIANT Result;
			VariantInit(&Result);
			OLECHAR* szGetSpecialURL = OLESTR("GetSpecialURL");
			hr = Host.pdispVal->GetIDsOfNames(IID_NULL, &szGetSpecialURL, 1, LOCALE_SYSTEM_DEFAULT, &dispid);
			assert(hr == S_OK);
			hr = Host.pdispVal->Invoke(dispid, IID_NULL, LOCALE_SYSTEM_DEFAULT, DISPATCH_METHOD, &DispParams, &Result, NULL, NULL);
			assert(hr == S_OK);
			hr = VariantChangeType(&Result, &Result, 0, VT_BSTR);
			assert(hr == S_OK);

			VariantCopy(&Param, &Result);
			OLECHAR* szNavigate = OLESTR("Navigate");
			hr = Host.pdispVal->GetIDsOfNames(IID_NULL, &szNavigate, 1, LOCALE_SYSTEM_DEFAULT, &dispid);
			assert(hr == S_OK);
			hr = Host.pdispVal->Invoke(dispid, IID_NULL, LOCALE_SYSTEM_DEFAULT, DISPATCH_METHOD, &DispParams, &Result, NULL, NULL);
			assert(hr == S_OK);
			hr = VariantChangeType(&Result, &Result, 0, VT_UINT);
			assert(hr == S_OK);
			assert(Result.uintVal == S_OK);

			VariantClear(&Result);
			VariantClear(&Param);
		}

		//    javascript   
		//	( ,      (CCashMaticDemoPlugin::Init)
		//	    ,       ,
		//	  ,    HTML-.
		//	      (CashMatic.Host.Navigate(CashMatic.Host.GetSpecialURL("finish"))),
		//	..   ""    )
		{
			VARIANTARG Param[2];
			VariantInit(&Param[0]);
			Param[0].vt = VT_BSTR;
			Param[0].bstrVal = SysAllocString(L"javascript");
			VariantInit(&Param[1]);
			Param[1].vt = VT_BSTR;
			Param[1].bstrVal = SysAllocString(L"alert(' javascript:' + String(2*3))");
			DISPPARAMS DispParams = {Param, NULL, _countof(Param), 0};
			VARIANT Result;
			VariantInit(&Result);
			OLECHAR* szExecScript = OLESTR("ExecScript");
			hr = Host.pdispVal->GetIDsOfNames(IID_NULL, &szExecScript, 1, LOCALE_SYSTEM_DEFAULT, &dispid);
			assert(hr == S_OK);
			hr = Host.pdispVal->Invoke(dispid, IID_NULL, LOCALE_SYSTEM_DEFAULT, DISPATCH_METHOD, &DispParams, &Result, NULL, NULL);

			if(hr == DISP_E_BADCALLEE) //    NDemia CashMatic KioskBrowser:
					hr = S_OK;		// ExecScript DISP_E_BADCALLEE     .

			assert(hr == S_OK);
			hr = VariantChangeType(&Result, &Result, 0, VT_UINT);
			assert(hr == S_OK);
			assert(Result.uintVal == S_OK);

			VariantClear(&Result);
			VariantClear(&Param[1]);
			VariantClear(&Param[0]);
		}

		VariantClear(&Host);
}
