////////////////////////////////////////////////////////////
//Project: NDemia CashMatic Demo plugin. v.1.0.0
//
//	Step 5.
//
//(C)opyright NDemia 2009
////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "CashMaticDemoPlugin.h"
#include <assert.h>
#include <wchar.h>

IID IID_ICashMaticPlugin = { 0x1288b75, 0xb4ea, 0x4d76, { 0x83, 0x22, 0x8b, 0x5a, 0xc4, 0xe8, 0x99, 0x95 } };
//  ICashMaticPlugin (   NDemia CashMatic)

const CLSID CCashMaticDemoPlugin::ClsId = 
{ 0x188e65e, 0xd900, 0x4056, { 0xac, 0x46, 0xc0, 0x46, 0x78, 0xe7, 0x9c, 0x6 } };


//  ICashMaticPlugin   IDispatch
//	( ,     ,
//	,     NDemia CashMatic   
//	,     )

// CashMatic
static PARAMDATA Param_CashMatic = {OLESTR("CashMatic"), VT_DISPATCH};

// ICashMaticPlugin, 
static METHODDATA ICashMaticPlugin_Methods[] =
{
	{OLESTR("Init"), &Param_CashMatic, 1, 7, CC_STDCALL, 1, DISPATCH_METHOD, VT_EMPTY},
};

// ICashMaticPlugin
static INTERFACEDATA ICashMaticPlugin_Interface = {ICashMaticPlugin_Methods, 1};

////////////////////////////////////////////////////////////
// CCashMaticDemoPlugin (  "CashMaticDemoPlugin.h")
////////////////////////////////////////////////////////////
//
CCashMaticDemoPlugin::CCashMaticDemoPlugin()
	:RefCount(1),
	pTypeInfo(NULL)
{
	//     ICashMaticPlugin
	CreateDispTypeInfo(&ICashMaticPlugin_Interface, LOCALE_SYSTEM_DEFAULT, &pTypeInfo);
		//  : S_OK,   
}

//
CCashMaticDemoPlugin::~CCashMaticDemoPlugin()
{
	if(pTypeInfo)
		pTypeInfo->Release();
}

// IUnknown
HRESULT CCashMaticDemoPlugin::QueryInterface(REFIID iid, void ** ppvObject)
{
	if(ppvObject)
	{
		if(IsEqualIID(iid, IID_IUnknown) || IsEqualIID(iid, IID_IDispatch) || IsEqualIID(iid, IID_ICashMaticPlugin))
		{
			*ppvObject = this;
			AddRef();
			return S_OK;
		}
		else
		{
			*ppvObject = NULL;
			return E_NOINTERFACE;
		}
	}
	else
		return E_INVALIDARG;
}

// IUnknown
ULONG CCashMaticDemoPlugin::AddRef()
{
	return InterlockedIncrement(&RefCount);
}

// IUnknown
ULONG CCashMaticDemoPlugin::Release(void)
{
		LONG cnt = InterlockedDecrement(&RefCount);
		if(!cnt)
				delete this;
		return cnt;
}

// IDispatch
HRESULT CCashMaticDemoPlugin::GetTypeInfoCount(unsigned int* pctinfo)
{
	if(pctinfo)
	{
		*pctinfo = 1;
		return S_OK;
	}
	else
		return E_INVALIDARG;
}


// IDispatch
HRESULT CCashMaticDemoPlugin::GetTypeInfo(unsigned int iTInfo, LCID lcid, ITypeInfo** ppTInfo)
{
	if(ppTInfo)
	{
		*ppTInfo = pTypeInfo;
		pTypeInfo->AddRef();
		return S_OK;
	}
	else
		return E_INVALIDARG;
}

// IDispatch
HRESULT CCashMaticDemoPlugin::GetIDsOfNames(REFIID riid, OLECHAR** rgszNames, unsigned int cNames, LCID lcid, DISPID* rgDispId)
{
	return DispGetIDsOfNames(pTypeInfo, rgszNames, cNames, rgDispId);
}

// IDispatch
HRESULT CCashMaticDemoPlugin::Invoke(DISPID dispIdMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult, EXCEPINFO* pExcepInfo, unsigned int FAR* puArgErr)
{
	return DispInvoke(this, pTypeInfo, dispIdMember, wFlags, pDispParams, pVarResult, pExcepInfo, puArgErr);
}

// ICashMaticPlugin
void CCashMaticDemoPlugin::Init(IDispatch* pCashMatic)
{
	//   CashMaticTerminal
	HRESULT hr;
	DISPID dispid;

	OLECHAR* szTerminal = OLESTR("Terminal");
	hr = pCashMatic->GetIDsOfNames(IID_NULL, &szTerminal, 1, LOCALE_SYSTEM_DEFAULT, &dispid);
	assert(hr == S_OK);

	VARIANT Terminal;
	VariantInit(&Terminal);

	DISPPARAMS NoParams = {NULL, NULL, 0, 0};
	hr = pCashMatic->Invoke(dispid, IID_NULL, LOCALE_SYSTEM_DEFAULT, DISPATCH_PROPERTYGET, &NoParams, &Terminal, NULL, NULL);
	assert(hr == S_OK);
	assert(Terminal.vt == VT_DISPATCH);
	//Ok,    CashMaticTerminal

	ICashMaticTerminal* pTerminal = static_cast<ICashMaticTerminal*>(Terminal.pdispVal);
	assert(pTerminal);
	pTerminal->SetExtender(new CCashMaticTerminalExtender(pCashMatic));
		//    CCashMaticTerminalExtender,   ICashMaticTerminalExtender
		//  SetExtender  (    ,         ICashMaticTerminal::RemoveExtender, .    NDemia CashMatic)

	VariantClear(&Terminal);

	//   CashMaticSession
	VARIANT Session;
	VariantInit(&Session);
	OLECHAR* szSession = OLESTR("Session");
	hr = pCashMatic->GetIDsOfNames(IID_NULL, &szSession, 1, LOCALE_SYSTEM_DEFAULT, &dispid);
	assert(hr == S_OK);
	hr = pCashMatic->Invoke(dispid, IID_NULL, LOCALE_SYSTEM_DEFAULT, DISPATCH_PROPERTYGET, &NoParams, &Session, NULL, NULL);
	assert(hr == S_OK);
	assert(Session.vt == VT_DISPATCH);
	//Ok,    CashMaticSession

	ICashMaticSession* pSession = static_cast<ICashMaticSession*>(Session.pdispVal);
	assert(pSession);
	pSession->SetExtender(new CCashMaticSessionExtender(pCashMatic));
		//    CCashMaticSessionExtender,   ICashMaticSessionExtender
		//  SetExtender  (    ,         ICashMaticSession::RemoveExtender, .    NDemia CashMatic)


	VariantClear(&Session);
}

