////////////////////////////////////////////////////////////
//Project: NDemia CashMatic Demo plugin. v.1.0.0
//
//	Step 5.
//
//(C)opyright NDemia 2009
////////////////////////////////////////////////////////////

#ifdef CASHMATICDEMOPLUGIN_EXPORTS
#define CASHMATICDEMOPLUGIN_API __declspec(dllexport)
#else
#define CASHMATICDEMOPLUGIN_API __declspec(dllimport)
#endif

class ICashMaticPlugin : public IDispatch
		//    NDemia CashMatic
{
	public:
		virtual void CALLBACK Init(IDispatch* pCashMatic) = 0;
};

extern IID IID_ICashMaticPlugin; //  ICashMaticPlugin (   NDemia CashMatic)

class ICashMaticTerminalExtender; //forward
class ICashMaticTerminal : public IDispatch
{
	public:
		virtual HRESULT CALLBACK Name(BSTR* pRetVal) = 0;
		virtual HRESULT CALLBACK ServiceVersionString(BSTR* pRetVal) = 0;
		virtual void CALLBACK Event(BSTR EventName) = 0;
		virtual HRESULT CALLBACK Failure(BOOL* pRetVal) = 0;
		virtual void CALLBACK SetFailState(BSTR FailName, BOOL State) = 0;
		virtual unsigned CALLBACK SetExtender(ICashMaticTerminalExtender*) = 0;
		virtual BOOL CALLBACK RemoveExtender(unsigned) = 0;
};

class ICashMaticTerminalExtender : public IDispatch
{
	public:
		virtual void CALLBACK OnGuiStartup(ICashMaticTerminal* pTerminal) = 0;
		virtual void CALLBACK OnGuiExit(ICashMaticTerminal* pTerminal) = 0;
		virtual void CALLBACK OnEvent(ICashMaticTerminal* pTerminal, BSTR EventName) = 0;
		virtual void CALLBACK OnFailure(ICashMaticTerminal* pTerminal, BSTR FailName, BOOL FailState) = 0;
		virtual void CALLBACK PreCashCollect(ICashMaticTerminal* pTerminal) = 0;
		virtual void CALLBACK PostCashCollect(ICashMaticTerminal* pTerminal) = 0;
		virtual void CALLBACK PreZReport(ICashMaticTerminal* pTerminal) = 0;
		virtual void CALLBACK PostZReport(ICashMaticTerminal* pTerminal) = 0;
};
extern const IID IID_ICashMaticTerminalExtender;

class ICashMaticSessionExtender; //forward
class ICashMaticSession : public IDispatch
{
	public:
		virtual void CALLBACK Reset() = 0;
		virtual void CALLBACK Start() = 0;
		virtual void CALLBACK Event(BSTR EventName) = 0;
		virtual void CALLBACK Finish() = 0;
		virtual void CALLBACK AddProp(BSTR PropName, BSTR PropValue) = 0;
		virtual BSTR CALLBACK GetProp(BSTR PropName) = 0;
		virtual HRESULT CALLBACK Text(BSTR* pRetVal) = 0;
		virtual unsigned CALLBACK SetExtender(ICashMaticSessionExtender*) = 0;
		virtual BOOL CALLBACK RemoveExtender(unsigned) = 0;
};

class ICashMaticSessionExtender : public IDispatch
{
	public:
		virtual void CALLBACK PreReset(ICashMaticSession* pSession) = 0;
		virtual void CALLBACK PostReset(ICashMaticSession* pSession) = 0;
		virtual void CALLBACK PreStart(ICashMaticSession* pSession) = 0;
		virtual void CALLBACK PostStart(ICashMaticSession* pSession) = 0;
		virtual void CALLBACK OnEvent(ICashMaticSession* pSession, BSTR EventName) = 0;
		virtual void CALLBACK PreFinish(ICashMaticSession* pSession) = 0;
		virtual void CALLBACK PostFinish(ICashMaticSession* pSession) = 0;
};
extern const IID IID_ICashMaticSessionExtender;

// CLSID  "CashMatic Demo plugin"
#define CLSID_CASHMATICDEMOPLUGIN "{0188E65E-D900-4056-AC46-C04678E79C06}"

class CCashMaticDemoPlugin
	: public ICashMaticPlugin
{
protected:
	LONG RefCount;
	ITypeInfo* pTypeInfo;
public:
	static const CLSID ClsId;
public:
	CCashMaticDemoPlugin();
	~CCashMaticDemoPlugin();

	//IUnknown
	virtual HRESULT STDMETHODCALLTYPE QueryInterface(REFIID iid, void ** ppvObject);
	virtual ULONG STDMETHODCALLTYPE AddRef();
	virtual ULONG STDMETHODCALLTYPE Release(void);

	//IDispatch
	virtual HRESULT STDMETHODCALLTYPE GetTypeInfoCount(unsigned int* pctinfo);
	virtual HRESULT STDMETHODCALLTYPE GetTypeInfo(unsigned int iTInfo, LCID lcid, ITypeInfo** ppTInfo);
	virtual HRESULT STDMETHODCALLTYPE GetIDsOfNames(REFIID riid, OLECHAR** rgszNames, unsigned int cNames, LCID lcid, DISPID* rgDispId);
	virtual HRESULT STDMETHODCALLTYPE Invoke(DISPID dispIdMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult, EXCEPINFO* pExcepInfo, unsigned int FAR* puArgErr);

	//ICashMaticPlugin
	virtual void CALLBACK Init(IDispatch* pCashMatic);
};

class CCashMaticTerminalExtender
	: public ICashMaticTerminalExtender
{
protected:
	LONG RefCount;
	ITypeInfo* pTypeInfo;

	IDispatch* pCashMatic;
public:
	CCashMaticTerminalExtender(IDispatch* pCashMatic);
	~CCashMaticTerminalExtender();

	//IUnknown
	virtual HRESULT STDMETHODCALLTYPE QueryInterface(REFIID iid, void ** ppvObject);
	virtual ULONG STDMETHODCALLTYPE AddRef();
	virtual ULONG STDMETHODCALLTYPE Release(void);

	//IDispatch
	virtual HRESULT STDMETHODCALLTYPE GetTypeInfoCount(unsigned int* pctinfo);
	virtual HRESULT STDMETHODCALLTYPE GetTypeInfo(unsigned int iTInfo, LCID lcid, ITypeInfo** ppTInfo);
	virtual HRESULT STDMETHODCALLTYPE GetIDsOfNames(REFIID riid, OLECHAR** rgszNames, unsigned int cNames, LCID lcid, DISPID* rgDispId);
	virtual HRESULT STDMETHODCALLTYPE Invoke(DISPID dispIdMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult, EXCEPINFO* pExcepInfo, unsigned int FAR* puArgErr);

	//ICashMaticTerminalExtender
	virtual void CALLBACK OnGuiStartup(ICashMaticTerminal* pTerminal);
	virtual void CALLBACK OnGuiExit(ICashMaticTerminal* pTerminal);
	virtual void CALLBACK OnEvent(ICashMaticTerminal* pTerminal, BSTR EventName);
	virtual void CALLBACK OnFailure(ICashMaticTerminal* pTerminal, BSTR FailName, BOOL FailState);
	virtual void CALLBACK PreCashCollect(ICashMaticTerminal* pTerminal);
	virtual void CALLBACK PostCashCollect(ICashMaticTerminal* pTerminal);
	virtual void CALLBACK PreZReport(ICashMaticTerminal* pTerminal);
	virtual void CALLBACK PostZReport(ICashMaticTerminal* pTerminal);

};

class CCashMaticSessionExtender
	: public ICashMaticSessionExtender
{
protected:
	LONG RefCount;
	ITypeInfo* pTypeInfo;

	IDispatch* pCashMatic;
public:
	CCashMaticSessionExtender(IDispatch* pCashMatic);
	~CCashMaticSessionExtender();

	//IUnknown
	virtual HRESULT STDMETHODCALLTYPE QueryInterface(REFIID iid, void ** ppvObject);
	virtual ULONG STDMETHODCALLTYPE AddRef();
	virtual ULONG STDMETHODCALLTYPE Release(void);

	//IDispatch
	virtual HRESULT STDMETHODCALLTYPE GetTypeInfoCount(unsigned int* pctinfo);
	virtual HRESULT STDMETHODCALLTYPE GetTypeInfo(unsigned int iTInfo, LCID lcid, ITypeInfo** ppTInfo);
	virtual HRESULT STDMETHODCALLTYPE GetIDsOfNames(REFIID riid, OLECHAR** rgszNames, unsigned int cNames, LCID lcid, DISPID* rgDispId);
	virtual HRESULT STDMETHODCALLTYPE Invoke(DISPID dispIdMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult, EXCEPINFO* pExcepInfo, unsigned int FAR* puArgErr);

	//ICashMaticSessionExtender
	virtual void CALLBACK PreReset(ICashMaticSession* pSession);
	virtual void CALLBACK PostReset(ICashMaticSession* pSession);
	virtual void CALLBACK PreStart(ICashMaticSession* pSession);
	virtual void CALLBACK PostStart(ICashMaticSession* pSession);
	virtual void CALLBACK OnEvent(ICashMaticSession* pSession, BSTR EventName);
	virtual void CALLBACK PreFinish(ICashMaticSession* pSession);
	virtual void CALLBACK PostFinish(ICashMaticSession* pSession);

	void Display(LPCWSTR pszHeader, ICashMaticSession* pSession); //      /        ,   CashMatic.Session.GetProp
};

extern HMODULE hModuleDll;	//  DLL - . dllmain.cpp

class ClassFactory : public IClassFactory
		//  CCashMaticDemoPlugin
{
protected:
	LONG RefCount;

public:
	ClassFactory();

	//IUnknown
	virtual HRESULT STDMETHODCALLTYPE QueryInterface(REFIID iid, void ** ppvObject);
	virtual ULONG STDMETHODCALLTYPE AddRef();
	virtual ULONG STDMETHODCALLTYPE Release(void);

	//IClassFactory
	virtual HRESULT STDMETHODCALLTYPE CreateInstance(IUnknown * pUnkOuter, REFIID riid, void ** ppvObject);
	virtual HRESULT STDMETHODCALLTYPE LockServer(BOOL fLock);

};

