////////////////////////////////////////////////////////////
//Project: NDemia CashMatic Demo plugin. v.1.0.0
//
//	Step 5.
//
//(C)opyright NDemia 2009
////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "CashMaticDemoPlugin.h"

// CClassFactory (  "CashMaticDemoPlugin.h")

ClassFactory::ClassFactory()
	:RefCount(1)
{
}

HRESULT ClassFactory::QueryInterface(REFIID iid, void ** ppvObject)
{
	if(ppvObject)
	{
		if(IsEqualIID(iid, IID_IUnknown) || IsEqualIID(iid, IID_IClassFactory))
		{
			*ppvObject = this;
			AddRef();
			return S_OK;
		}
		else
		{
			*ppvObject = NULL;
			return E_NOINTERFACE;
		}
	}
	else
		return E_INVALIDARG;
}

ULONG ClassFactory::AddRef()
{
	return InterlockedIncrement(&RefCount);
}

ULONG ClassFactory::Release(void)
{
		LONG cnt = InterlockedDecrement(&RefCount);
		if(!cnt)
				delete this;
		return cnt;
}

HRESULT ClassFactory::CreateInstance(IUnknown * pUnkOuter, REFIID riid, void ** ppvObject)
{
	if(ppvObject)
	{
		if(
			IsEqualIID(riid, IID_IUnknown)
			|| IsEqualIID(riid, IID_IDispatch)
			|| IsEqualIID(riid, IID_ICashMaticPlugin)
		)
		{
			*ppvObject = new CCashMaticDemoPlugin;
			return S_OK;
		}
		else
		{
			*ppvObject = NULL;
			return E_NOINTERFACE;
		}
	}
	else
		return E_INVALIDARG;
}

HRESULT ClassFactory::LockServer(BOOL fLock)
{
	return CoLockObjectExternal(this, fLock, false);
}
