////////////////////////////////////////////////////////////
//Project: NDemia CashMatic Demo plugin. v.1.0.0
//
//	Step 6.
//
//(C)opyright NDemia 2009
////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "CashMaticDemoPlugin.h"
#include <assert.h>

// {02A6987B-E3F2-451c-A81D-35D74CCDE78E}
const IID IID_ICashMaticSessionExtender =
{ 0x2a6987b, 0xe3f2, 0x451c, { 0xa8, 0x1d, 0x35, 0xd7, 0x4c, 0xcd, 0xe7, 0x8e } };


//  ICashMaticSessionExtender   IDispatch
//	( ,     ,
//	,     NDemia CashMatic   
//	,     )

// pSession
static PARAMDATA Param_Session = {OLESTR("pSession"), VT_DISPATCH};
	//-, VT_DISPATCH -    ,  pSession      ICashMaticSession*,
	//  ,  IDispatch -      ICashMaticSession,      .

//  ICashMaticSessionExtender::OnEvent: pSession, EventName
static PARAMDATA Params_OnEvent [] = 
{
	{OLESTR("pSession"), VT_DISPATCH},
	{OLESTR("EventName"), VT_BSTR},
};

// ICashMaticSessionExtender, 
static METHODDATA ICashMaticSessionExtender_Methods[] =
{
	{OLESTR("PreReset"), &Param_Session, 1, 7, CC_STDCALL, 1, DISPATCH_METHOD, VT_EMPTY},
	{OLESTR("PostReset"), &Param_Session, 2, 8, CC_STDCALL, 1, DISPATCH_METHOD, VT_EMPTY},
	{OLESTR("PreStart"), &Param_Session, 3, 9, CC_STDCALL, 1, DISPATCH_METHOD, VT_EMPTY},
	{OLESTR("PostStart"), &Param_Session, 4, 10, CC_STDCALL, 1, DISPATCH_METHOD, VT_EMPTY},
	{OLESTR("OnEvent"), Params_OnEvent, 5, 11, CC_STDCALL, _countof(Params_OnEvent), DISPATCH_METHOD, VT_EMPTY},
	{OLESTR("PreFinish"), &Param_Session, 6, 12, CC_STDCALL, 1, DISPATCH_METHOD, VT_EMPTY},
	{OLESTR("PostFinish"), &Param_Session, 7, 13, CC_STDCALL, 1, DISPATCH_METHOD, VT_EMPTY},
};

// ICashMaticSessionExtender
static INTERFACEDATA ICashMaticSessionExtender_Interface = {ICashMaticSessionExtender_Methods, _countof(ICashMaticSessionExtender_Methods)};

////////////////////////////////////////////////////////////
// CCashMaticSessionExtender (  "CashMaticDemoPlugin.h")
////////////////////////////////////////////////////////////
//
CCashMaticSessionExtender::CCashMaticSessionExtender(IDispatch* pCashMatic)
	:RefCount(1),
	pTypeInfo(NULL),
	pCashMatic(pCashMatic)
{
	//     ICashMaticPlugin
	CreateDispTypeInfo(&ICashMaticSessionExtender_Interface, LOCALE_SYSTEM_DEFAULT, &pTypeInfo);
		//  : S_OK,   
	pCashMatic->AddRef();
}

//
CCashMaticSessionExtender::~CCashMaticSessionExtender()
{
	pCashMatic->Release();
	if(pTypeInfo)
		pTypeInfo->Release();
}

// IUnknown
HRESULT CCashMaticSessionExtender::QueryInterface(REFIID iid, void ** ppvObject)
{
	if(ppvObject)
	{
		if(IsEqualIID(iid, IID_IUnknown) || IsEqualIID(iid, IID_IDispatch) || IsEqualIID(iid, IID_ICashMaticSessionExtender))
		{
			*ppvObject = this;
			AddRef();
			return S_OK;
		}
		else
		{
			*ppvObject = NULL;
			return E_NOINTERFACE;
		}
	}
	else
		return E_INVALIDARG;
}

// IUnknown
ULONG CCashMaticSessionExtender::AddRef()
{
	return InterlockedIncrement(&RefCount);
}

// IUnknown
ULONG CCashMaticSessionExtender::Release(void)
{
		LONG cnt = InterlockedDecrement(&RefCount);
		if(!cnt)
				delete this;
		return cnt;
}

// IDispatch
HRESULT CCashMaticSessionExtender::GetTypeInfoCount(unsigned int* pctinfo)
{
	if(pctinfo)
	{
		*pctinfo = 1;
		return S_OK;
	}
	else
		return E_INVALIDARG;
}


// IDispatch
HRESULT CCashMaticSessionExtender::GetTypeInfo(unsigned int iTInfo, LCID lcid, ITypeInfo** ppTInfo)
{
	if(ppTInfo)
	{
		*ppTInfo = pTypeInfo;
		pTypeInfo->AddRef();
		return S_OK;
	}
	else
		return E_INVALIDARG;
}

// IDispatch
HRESULT CCashMaticSessionExtender::GetIDsOfNames(REFIID riid, OLECHAR** rgszNames, unsigned int cNames, LCID lcid, DISPID* rgDispId)
{
	return DispGetIDsOfNames(pTypeInfo, rgszNames, cNames, rgDispId);
}

// IDispatch
HRESULT CCashMaticSessionExtender::Invoke(DISPID dispIdMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult, EXCEPINFO* pExcepInfo, unsigned int FAR* puArgErr)
{
	return DispInvoke(this, pTypeInfo, dispIdMember, wFlags, pDispParams, pVarResult, pExcepInfo, puArgErr);
}

// ICashMaticSessionExtender
void CCashMaticSessionExtender::PreReset(ICashMaticSession* pSession)
{
}

// ICashMaticSessionExtender
void CCashMaticSessionExtender::PostReset(ICashMaticSession* pSession)
{
}

// ICashMaticSessionExtender
void CCashMaticSessionExtender::PreStart(ICashMaticSession* pSession)
{
}

// ICashMaticSessionExtender
void CCashMaticSessionExtender::PostStart(ICashMaticSession* pSession)
{
	Display(L"  ", pSession);
}

// ICashMaticSessionExtender
void CCashMaticSessionExtender::OnEvent(ICashMaticSession* pSession, BSTR EventName)
{
	if(lstrcmpiW(EventName, L"DemoButton") == 0)
		MessageBox(NULL, TEXT("  "), TEXT("NDemia CashMatic Demo plugin"), MB_OK|MB_ICONINFORMATION);
	else if(lstrcmpiW(EventName, L"Demo.ToLower") == 0)
	{
		BSTR pText = pSession->GetProp(OLESTR("Demo.Text"));
		if(pText)
		{
			CharLower(pText);
			pSession->AddProp(OLESTR("Demo.Text"), pText);
		}

	}
	else if(lstrcmpiW(EventName, L"Demo.ToUpper") == 0)
	{
		BSTR pText = pSession->GetProp(OLESTR("Demo.Text"));
		if(pText)
		{
			CharUpper(pText);
			pSession->AddProp(OLESTR("Demo.Text"), pText);
		}

	}
}

// ICashMaticSessionExtender
void CCashMaticSessionExtender::PreFinish(ICashMaticSession* pSession)
{
}

// ICashMaticSessionExtender
void CCashMaticSessionExtender::PostFinish(ICashMaticSession* pSession)
{
	Display(L"  ", pSession);
}

void CCashMaticSessionExtender::Display(LPCWSTR pszHeader, ICashMaticSession* pSession)
{
	HRESULT hr;
	DISPID dispid;
	DISPPARAMS NoParams = {NULL, NULL, 0, 0};

	VARIANT Result;
	VariantInit(&Result);
	OLECHAR* szText = OLESTR("Text");
	hr = pSession->GetIDsOfNames(IID_NULL, &szText, 1, LOCALE_SYSTEM_DEFAULT, &dispid);
	assert(hr == S_OK);
	hr = pSession->Invoke(dispid, IID_NULL, LOCALE_SYSTEM_DEFAULT, DISPATCH_PROPERTYGET, &NoParams, &Result, NULL, NULL);
	assert(hr == S_OK);
	hr = VariantChangeType(&Result, &Result, 0, VT_BSTR);
	assert(hr == S_OK);

	MessageBoxW(NULL, Result.bstrVal, pszHeader, MB_OK|MB_ICONINFORMATION);
}