////////////////////////////////////////////////////////////
//Project: NDemia CashMatic Demo plugin. v.1.0.0
//
//	Step 6.
//
//(C)opyright NDemia 2009
////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "CashMaticDemoPlugin.h"
#include <assert.h>

// {00735A83-6101-49ae-B2E5-77BA59B3D6A9}
const IID IID_ICashMaticTerminalExtender =
{ 0x735a83, 0x6101, 0x49ae, { 0xb2, 0xe5, 0x77, 0xba, 0x59, 0xb3, 0xd6, 0xa9 } };

//  ICashMaticTerminalExtender   IDispatch
//	( ,     ,
//	,     NDemia CashMatic   
//	,     )

// pTerminal
static PARAMDATA Param_Terminal = {OLESTR("pTerminal"), VT_DISPATCH};
	//-, VT_DISPATCH -    ,  pTerminal      ICashMaticTerminal*,
	//  ,  IDispatch -      ICashMaticTerminal,      .

//  ICashMaticTerminalExtender::OnEvent: pTerminal, EventName
static PARAMDATA Params_OnEvent [] = 
{
	{OLESTR("pTerminal"), VT_DISPATCH},
	{OLESTR("EventName"), VT_BSTR},
};

//  ICashMaticTerminalExtender::OnFailure: pTerminal, FailName, FailState
static PARAMDATA Params_OnFailure [] = 
{
	{OLESTR("pTerminal"), VT_DISPATCH},
	{OLESTR("FailName"), VT_BSTR},
	{OLESTR("FailState"), VT_BOOL},
};

// ICashMaticTerminalExtender, 
static METHODDATA ICashMaticTerminalExtender_Methods[] =
{
	{OLESTR("OnGuiStartup"), &Param_Terminal, 1, 7, CC_STDCALL, 1, DISPATCH_METHOD, VT_EMPTY},
	{OLESTR("OnGuiExit"), &Param_Terminal, 2, 8, CC_STDCALL, 1, DISPATCH_METHOD, VT_EMPTY},
	{OLESTR("OnEvent"), Params_OnEvent, 3, 9, CC_STDCALL, _countof(Params_OnEvent), DISPATCH_METHOD, VT_EMPTY},
	{OLESTR("OnFailure"), Params_OnFailure, 4, 10, CC_STDCALL, _countof(Params_OnFailure), DISPATCH_METHOD, VT_EMPTY},
	{OLESTR("PreCashCollect"), &Param_Terminal, 5, 11, CC_STDCALL, 1, DISPATCH_METHOD, VT_EMPTY},
	{OLESTR("PostCashCollect"), &Param_Terminal, 6, 12, CC_STDCALL, 1, DISPATCH_METHOD, VT_EMPTY},
	{OLESTR("PreZReport"), &Param_Terminal, 7, 13, CC_STDCALL, 1, DISPATCH_METHOD, VT_EMPTY},
	{OLESTR("PostZReport"), &Param_Terminal, 8, 14, CC_STDCALL, 1, DISPATCH_METHOD, VT_EMPTY},
};

// ICashMaticTerminalExtender
static INTERFACEDATA ICashMaticTerminalExtender_Interface = {ICashMaticTerminalExtender_Methods, _countof(ICashMaticTerminalExtender_Methods)};

////////////////////////////////////////////////////////////
// CCashMaticTerminalExtender (  "CashMaticDemoPlugin.h")
////////////////////////////////////////////////////////////
//
CCashMaticTerminalExtender::CCashMaticTerminalExtender(IDispatch* pCashMatic)
	:RefCount(1),
	pTypeInfo(NULL),
	pCashMatic(pCashMatic)
{
	//     ICashMaticPlugin
	CreateDispTypeInfo(&ICashMaticTerminalExtender_Interface, LOCALE_SYSTEM_DEFAULT, &pTypeInfo);
		//  : S_OK,   
	pCashMatic->AddRef();
}

//
CCashMaticTerminalExtender::~CCashMaticTerminalExtender()
{
	pCashMatic->Release();
	if(pTypeInfo)
		pTypeInfo->Release();
}

// IUnknown
HRESULT CCashMaticTerminalExtender::QueryInterface(REFIID iid, void ** ppvObject)
{
	if(ppvObject)
	{
		if(IsEqualIID(iid, IID_IUnknown) || IsEqualIID(iid, IID_IDispatch) || IsEqualIID(iid, IID_ICashMaticTerminalExtender))
		{
			*ppvObject = this;
			AddRef();
			return S_OK;
		}
		else
		{
			*ppvObject = NULL;
			return E_NOINTERFACE;
		}
	}
	else
		return E_INVALIDARG;
}

// IUnknown
ULONG CCashMaticTerminalExtender::AddRef()
{
	return InterlockedIncrement(&RefCount);
}

// IUnknown
ULONG CCashMaticTerminalExtender::Release(void)
{
		LONG cnt = InterlockedDecrement(&RefCount);
		if(!cnt)
				delete this;
		return cnt;
}

// IDispatch
HRESULT CCashMaticTerminalExtender::GetTypeInfoCount(unsigned int* pctinfo)
{
	if(pctinfo)
	{
		*pctinfo = 1;
		return S_OK;
	}
	else
		return E_INVALIDARG;
}


// IDispatch
HRESULT CCashMaticTerminalExtender::GetTypeInfo(unsigned int iTInfo, LCID lcid, ITypeInfo** ppTInfo)
{
	if(ppTInfo)
	{
		*ppTInfo = pTypeInfo;
		pTypeInfo->AddRef();
		return S_OK;
	}
	else
		return E_INVALIDARG;
}

// IDispatch
HRESULT CCashMaticTerminalExtender::GetIDsOfNames(REFIID riid, OLECHAR** rgszNames, unsigned int cNames, LCID lcid, DISPID* rgDispId)
{
	return DispGetIDsOfNames(pTypeInfo, rgszNames, cNames, rgDispId);
}

// IDispatch
HRESULT CCashMaticTerminalExtender::Invoke(DISPID dispIdMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult, EXCEPINFO* pExcepInfo, unsigned int FAR* puArgErr)
{
	return DispInvoke(this, pTypeInfo, dispIdMember, wFlags, pDispParams, pVarResult, pExcepInfo, puArgErr);
}

// ICashMaticTerminalExtender
void CCashMaticTerminalExtender::OnGuiStartup(ICashMaticTerminal* pTerminal)
{
}

// ICashMaticTerminalExtender
void CCashMaticTerminalExtender::OnGuiExit(ICashMaticTerminal* pTerminal)
{
}

// ICashMaticTerminalExtender
void CCashMaticTerminalExtender::OnEvent(ICashMaticTerminal* pTerminal, BSTR EventName)
{
	if(lstrcmpiW(EventName, L"DemoButton") == 0)
		MessageBox(NULL, TEXT(" "), TEXT("NDemia CashMatic Demo plugin"), MB_OK|MB_ICONINFORMATION);
}

// ICashMaticTerminalExtender
void CCashMaticTerminalExtender::OnFailure(ICashMaticTerminal* pTerminal, BSTR FailName, BOOL FailState)
{
}

// ICashMaticTerminalExtender
void CCashMaticTerminalExtender::PreCashCollect(ICashMaticTerminal* pTerminal)
{
}

// ICashMaticTerminalExtender
void CCashMaticTerminalExtender::PostCashCollect(ICashMaticTerminal* pTerminal)
{
}

// ICashMaticTerminalExtender
void CCashMaticTerminalExtender::PreZReport(ICashMaticTerminal* pTerminal)
{
}

// ICashMaticTerminalExtender
void CCashMaticTerminalExtender::PostZReport(ICashMaticTerminal* pTerminal)
{
}
